import ui
#import mp3play
import controlTypes
from tones import beep
lastHidden=0
stack=0
import re
import pickle
hidden={}
from ctypes import *
import appModuleHandler
import gui,wx
import winKernel
import winUser
from logHandler import log
import os
impPath = os.path.abspath(os.path.dirname(__file__))
import globalPluginHandler
from sys import path
path.append(impPath)
import threading
import addonHandler
import api
from speech import cancelSpeech
import config
from configobj import *
import scriptHandler
addonHandler.initTranslation()
_basePath = os.path.dirname(os.path.abspath(__file__))
_configFile = os.path.join(_basePath,"settings.ini")
_savePath = os.path.join(_basePath, "settings")
psapi = windll.psapi
if not os.path.isfile(_configFile):
	config = ConfigObj()
	config.filename = _configFile
	config ["status"]="enabled"
	config.write()
def setPriority(pid=None,priority=1):
    """ Set The Priority of a Windows Process.  Priority is a value between 0-5 where
        2 is normal priority.  Default sets the priority of the current
        python process but can take any valid process ID. """
        
    import win32api,win32process
    
    priorityclasses = [win32process.IDLE_PRIORITY_CLASS,
                       win32process.BELOW_NORMAL_PRIORITY_CLASS,
                       win32process.NORMAL_PRIORITY_CLASS,
                       win32process.ABOVE_NORMAL_PRIORITY_CLASS,
                       win32process.HIGH_PRIORITY_CLASS,
                       win32process.REALTIME_PRIORITY_CLASS]
    if pid == None:
        pid = win32api.GetCurrentProcessId()
    handle = win32api.OpenProcess(983040|1048576|4095, True, pid)
    win32process.SetPriorityClass(handle, priorityclasses[priority])
def getPriority(pid=None):
    """ Set The Priority of a Windows Process.  Priority is a value between 0-5 where
        2 is normal priority.  Default sets the priority of the current
        python process but can take any valid process ID. """
        
    import win32api,win32process,win32con
    
    priorityclasses = [win32process.IDLE_PRIORITY_CLASS,
                       win32process.BELOW_NORMAL_PRIORITY_CLASS,
                       win32process.NORMAL_PRIORITY_CLASS,
                       win32process.ABOVE_NORMAL_PRIORITY_CLASS,
                       win32process.HIGH_PRIORITY_CLASS,
                       win32process.REALTIME_PRIORITY_CLASS]
    if pid == None:
        pid = win32api.GetCurrentProcessId()
    handle = win32api.OpenProcess(win32con.PROCESS_ALL_ACCESS, True, pid)
    return win32process.GetPriorityClass(handle)

def getFilePath():
	global hidden,stack
	file = standarFileName("hiddenwindows")
	file = file+".dat"
	path = os.path.join(_basePath, file)
	abspath=os.path.abspath(path)
	return open(abspath,"rb")
def getFileLoad():
	global hidden,stack
	file = standarFileName("hiddenwindows")
	file = file+".dat"
	path = os.path.join(_basePath, file)
	abspath=os.path.abspath(path)
	return abspath

def getFileWrite():
	global hidden,stack
	file = standarFileName("hiddenwindows")
	file = file+".dat"
	path = os.path.join(_basePath, file)
	abspath=os.path.abspath(path)
	return open(abspath,"wb")

def standarFileName(fileName):
	global hidden,stack
	notAllowed = re.compile("\?|:|\*|\t|<|>|\"|\/|\\||") # Invalid characters
	allowed = re.sub(notAllowed, "", fileName)
	return allowed
def savelist():
	global hidden,stack
	f = getFileWrite()
	pickle.dump(hidden,f)
	f.close
def hidewindow(num):
	global hidden,lastHidden,stack
	num=num+(stack*10)
	try:
		#is it a window what we want to show, or has it disappeared? nUtils runs a forever running while loop for this, but we don't want to waste resources. so we just check here.
		if hidden[num][0]==api.getForegroundObject().windowHandle:
			hidden.pop(num)
			hidewindow(num)
		elif winUser.isWindow(hidden[num][0])==1:
			value=hidden[num][0]
			beep(180,180)
			winUser.user32.ShowWindowAsync(value,3)
			winUser.user32.SetFocus(value)
			hidden.pop(num)
			lastHidden=0
			return
		else:
			hidden.pop(num)
			hidewindow(num)
		return
	except KeyError:
		current=api.getForegroundObject()
		appName=appModuleHandler.getAppNameFromProcessID(current.processID,True)
		title=current.name
		current=current.windowHandle
		if (title==None):
			beep(300,300)
			return

		if title=="Program Manager" or title=="Taskbar":
			beep(300,300)
			return
		winUser.user32.ShowWindowAsync(current,0)
		temp=[]
		temp.append(current)
		temp.append(title)
		temp.append(appName)
		temp.append(num)
		hidden[num]=temp
		beep(80,180)
		pass
	savelist()
def clickWindow(object):
	object.setFocus()

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	scriptCategory="winWizard"
	def __init__(self):
		global hidden,stack
		globalPluginHandler.GlobalPlugin.__init__(self)
		for n in range(1,10):
			self.bindGesture("kb:shift+windows+%s" % n, "window")
		self.bindGesture("kb:shift+windows+0", "window")
		
		try:
			hidden=pickle.load(getFilePath())
		except:
			hidden={}
			# The dialog instance is initialy None.
			# We only create it on the first time the script is called.
		self._systrayListDialog = None
		self._priorityListDialog = None
	def createList(self):
		global hidden,wlist,stack
		if len(hidden)==0:
			ui.message(_("There are no windows currently hidden."))
			return
		wlist=[]
		for i,obj in hidden.items():
			if winUser.isWindow(obj[0])==1:
				wlist.append(_("{2} {0}, from process {1}").format(obj[1],obj[2],obj[3]))
		if not self._systrayListDialog:
			self._systrayListDialog = SystrayListDialog(gui.mainFrame, wlist)
		# Update the list on the dialog
		self._systrayListDialog.updateSystray(wlist)
		# Show the window if it is Hidden
		if not self._systrayListDialog.IsShown():
			gui.mainFrame.prePopup()
			self._systrayListDialog.Show()
			self._systrayListDialog.Centre()
			gui.mainFrame.postPopup()
	def priorityList(self):
		global plist
		plist=[]
		plist.append(_("background"))
		plist.append(_("below normal"))
		plist.append(_("normal"))
		plist.append(_("above normal"))
		plist.append(_("high"))
		plist.append(_("realtime"))

		if not self._priorityListDialog:
			self._priorityListDialog = PriorityListDialog(gui.mainFrame, plist)
		# Update the list on the dialog
		self._priorityListDialog.updateSystray(plist)
		# Show the window if it is Hidden
		if not self._priorityListDialog.IsShown():
			gui.mainFrame.prePopup()
			self._priorityListDialog.Show()
			self._priorityListDialog.Centre()
			gui.mainFrame.postPopup()
	def script_changePriority(self,gesture):
		"""Prompts to change the priority of the current process"""
		self.priorityList()
	def script_debug(self,gesture):
		o=api.getFocusObject().windowHandle


	def script_hideFirstAvailable(self,gesture):
		"""hides the current window in the first available slot"""
		global hidden,lastHidden,stack

		curnum=1
		try:
			while (hidden[curnum]!=None):
				curnum=curnum+1
		except:
			pass
		lastHidden=curnum
		hidewindow(curnum)
	def script_unhideLastWindow(self,gesture):
		"""unhides the last hidden window"""
		global lastHidden,hidden
		if lastHidden==0:
			ui.message(_("There is no window recorded as last hidden window"))
			return
		hidewindow(lastHidden)

	def script_windowlist(self,gesture):
		"""shows a list of hidden windows"""
		self.createList()

	def script_killProcess(self,gesture):
		"""kills the current process"""
		focus=api.getFocusObject()
		appName=appModuleHandler.getAppNameFromProcessID(focus.processID,True)
		kernel32=winKernel.kernel32
		pid=focus.processID
		handle = kernel32.OpenProcess(1, 0, pid)
		beep(90,300)
		return (0 != kernel32.TerminateProcess(handle, 0))


	def script_window(self,gesture):
		"""hides a window in the given slot"""
		num=int(gesture.mainKeyName[-1])
		hidewindow(num)
	def script_changeTitle(self,gesture):
		"""promps to change the title of the current window"""
		window=api.getForegroundObject()
		try:
			d = wx.TextEntryDialog(gui.mainFrame, _("Enter the new title for this window:"), _("Change window title"))
			def callback(result):
				if result == wx.ID_OK:
					newtitle=str(d.GetValue())
					winUser.user32.SetWindowTextW(window.windowHandle,newtitle)
			gui.runScriptModalDialog(d, callback)
		except:
			gui.messageBox(_("Can't change window title"), _("Error"), wx.OK|wx.ICON_ERROR)
	def script_stackdown(self,gesture):
		"""moves left a stack of possible window slots"""
		global stack
		stack-=1
		if stack<0: stack=0
		ui.message(_("stack {0}").format(stack))
	def script_stackup(self,gesture):
		"""moves right a stack of possible window slots"""
		global stack
		stack+=1
		if stack>10: stack=10
		ui.message(_("stack {0}").format(stack))
	def script_cycleWindows(self,gesture):
		"""cycles through top-level windows"""
		nwp=0
		nwn=0
		try:
			fg=api.getForegroundObject().parent
			fgp=fg.appModule
		except:
			ui.message("Can't retrieve window information for this object.")
		try:
			if not fg.simplePrevious.appModule==fgp:
				if fg.simpleNext.appModule==fgp:
					nwn=fg.simpleNext
			if not fg.simpleNext.appModule==fgp:
				if fg.simplePrevious.appModule==fgp:
					nwp=fg.simplePrevious
		except AttributeError:
			ui.message("This is not a valid window. You are probably on the desktop or the start button.")
			pass
		if nwn==0 and nwp==0:
			ui.message("This window has no top level windows to cycle to.")
		elif not nwn==0 and not nwp==0:
			ui.message("Multiple top level windows detected.")
		elif not nwn==0:
			clickWindow(nwn)
		elif not nwp==0:
			clickWindow(nwp)
	__gestures = {
"kb:windows+tab":"cycleWindows",
"kb:shift+windows+l": "windowlist",
#"kb:shift+windows+d": "debug",
"kb:shift+windows+h": "hideFirstAvailable",
"kb:shift+windows+p": "changePriority",
"kb:NVDA+windows+h": "unhideLastWindow",
"kb:windows+F4": "killProcess",
"kb:alt+control+t": "changeTitle",
"kb:shift+windows+leftArrow": "stackdown",
"kb:shift+windows+rightArrow": "stackup"
}

class SystrayListDialog(wx.Dialog):
	def __init__(self, parent, wlist, title=_("Window List")):
		super(SystrayListDialog, self).__init__(parent, title=title)
		# Create interface
		mainSizer = wx.BoxSizer(wx.VERTICAL)
		tasksSizer = wx.BoxSizer(wx.VERTICAL)
		tasksLabel = wx.StaticText(self, -1, label=_("Window list"))
		tasksSizer.Add(tasksLabel)
		self.listBox = wx.ListBox(self, wx.ID_ANY, style=wx.LB_SINGLE, size=(550, 250))
		tasksSizer.Add(self.listBox, proportion=8)
		mainSizer.Add(tasksSizer)
		# Create buttons.
		# Buttons are in a horizontal row
		buttonsSizer = wx.BoxSizer(wx.HORIZONTAL)
		showButtonID= wx.NewIdRef()
		showButton= wx.Button(self, showButtonID, _("&Show Window"))
		buttonsSizer.Add(showButton)
		cancelButton = wx.Button(self, wx.ID_CANCEL)
		self.Bind(wx.EVT_BUTTON, self.onShow, id=showButtonID)
		buttonsSizer.Add(cancelButton)
		self.SetSizer(mainSizer)
		mainSizer.Fit(self)
	def onShow(self,evt):
		global hidden,wlist,stack
		handle=self.listBox.GetString(self.listBox.GetSelection())
		num=int(handle.split(" ")[0])
		handle=hidden[num][0]
		try:
			value=hidden[num][0]
			beep(180,180)
			winUser.user32.ShowWindowAsync(value,3)
			#winUser.user32.SetFocus(value,1)
			hidden.pop(num)

		except:
			pass
		savelist()
		self.Destroy()
		self=None

	def updateSystray(self, wlist):
		global hidden,stack
		self.listBox.SetItems([obj for obj in wlist])
		self.listBox.SetFocus()

class PriorityListDialog(wx.Dialog):
	def __init__(self, parent, plist, title=_("Set Priority for process")):
		super(PriorityListDialog, self).__init__(parent, title=title)
		# Create interface
		mainSizer = wx.BoxSizer(wx.VERTICAL)
		tasksSizer = wx.BoxSizer(wx.VERTICAL)
		tasksLabel = wx.StaticText(self, -1, label=_("Window list"))
		tasksSizer.Add(tasksLabel)
		self.comboBox = wx.ComboBox(self, wx.NewId(), style=wx.CB_READONLY, size=(550, 250))
		tasksSizer.Add(self.comboBox, proportion=8)
		mainSizer.Add(tasksSizer)
		# Create buttons.
		# Buttons are in a horizontal row
		buttonsSizer = wx.BoxSizer(wx.HORIZONTAL)
		okButtonID= wx.NewId()
		okButton= wx.Button(self, okButtonID, _("&Ok"))
		self.Bind(wx.EVT_BUTTON, self.onOk, id=okButtonID)
		buttonsSizer.Add(okButton)
		okButton.SetDefault()
		cancelButton = wx.Button(self, wx.ID_CANCEL)
		self.Bind(wx.EVT_BUTTON, self.onOk, id=okButtonID)
		buttonsSizer.Add(cancelButton)
		self.SetSizer(mainSizer)
		mainSizer.Fit(self)
	def onOk(self,evt):
		global plist
		handle=self.comboBox.GetSelection()
		log.info(handle)
		focus=api.getFocusObject()
		appName=appModuleHandler.getAppNameFromProcessID(focus.processID,True)
		pid=focus.processID
		setPriority(pid,handle)

		self.Destroy()
		self=None

	def updateSystray(self, plist):
		self.comboBox.SetItems([obj for obj in plist])
		self.comboBox.Select(2)
		self.comboBox.SetFocus()